//
// Global definitions and structures
//

#define _FUSE_MAX_WATT		450
#define _FUSE_MAX_AMPS		200

#define _RELAIS				LATBbits.LATB3
#define _KEY_ONOFF			PORTBbits.RB0
#define _KEY_MINUS			PORTBbits.RB1
#define _KEY_PLUS			PORTBbits.RB2

#define _LCD_DATA_LAT 		LATC					// Latch for LCD data

#define _LCD_RW   			LATCbits.LATC2   		// PORT for RW
#define _LCD_RS   			LATCbits.LATC1   		// PORT for RS
#define _LCD_E	    		LATCbits.LATC3  		// PORT for E

#define LCD_INIT			0b100
#define LCD_CMD				0b110
#define LCD_DATA			0b001

#define FUSE_WATT			0x0
#define FUSE_AMPS			0x1

#define POWER_REAL			0x0
#define POWER_APPARENT		0x1
#define POWER_COMPLEX		0x2
#define POWER_LASTMODE		0x3


//
// Functions
//

/* cpu.c */
void CPU_Init (void);

/* lcd.c */
void LCD_Init (void);
void LCD_SetCursor (unsigned char x, unsigned char y);
void LCD_WriteString (char *buffer);
void LCD_senddata (unsigned char type, unsigned char data);

/* timer.c */
void isr (void);
void TMR0_Init (void);
void TMR3_Init (unsigned char msec);
