#include	<p18cxxx.h>
#include	"Regeltrafo.h"


void CPU_Init (void) {

	/* PORT A */

	LATAbits.LATA0   = 0x0;		// RA0/AN0	Uin
	LATAbits.LATA1   = 0x0;		// RA1/AN1	Iin
	LATAbits.LATA2   = 0x0;		// RA2/AN2	n/c
	LATAbits.LATA3   = 0x0;		// RA3/AN3	n/c
	LATAbits.LATA4   = 0x0;		// RA4/AN4	n/c
	LATAbits.LATA5   = 0x0;		// RA5/AN5	n/c
	LATAbits.LATA6   = 0x0;		// RA6/AN6	n/c
	LATAbits.LATA7   = 0x0;		// RA7/AN7	n/c

	TRISAbits.TRISA0 = 0x1;		// RA0/AN0	Uin
	TRISAbits.TRISA1 = 0x1;		// RA1/AN1	Iin
	TRISAbits.TRISA2 = 0x0;		// RA2/AN2	n/c
	TRISAbits.TRISA3 = 0x0;		// RA3/AN3	n/c
	TRISAbits.TRISA4 = 0x0;		// RA4/AN4	n/c
	TRISAbits.TRISA5 = 0x0;		// RA5/AN5	n/c
	TRISAbits.TRISA6 = 0x0;		// RA6/AN6	n/c
	TRISAbits.TRISA7 = 0x0;		// RA7/AN7	n/c


	/* PORT B */

	LATBbits.LATB0   = 0x0;		// RB0		ONOFF		
	LATBbits.LATB1   = 0x0;		// RB1		KEY+
	LATBbits.LATB2   = 0x0;		// RB2		KEY-
	LATBbits.LATB3   = 0x0;		// RB3		RELAIS
	LATBbits.LATB4   = 0x0;		// RB4		n/c
	LATBbits.LATB5   = 0x0;		// RB5		n/c
	LATBbits.LATB6   = 0x0;		// RB6		PGC
	LATBbits.LATB7   = 0x0;		// RB7		PGD

	TRISBbits.TRISB0 = 0x1;		// RB0		ONOFF
	TRISBbits.TRISB1 = 0x1;		// RB1		KEY+
	TRISBbits.TRISB2 = 0x1;		// RB2		KEY-
	TRISBbits.TRISB3 = 0x0;		// RB3		RELAIS
	TRISBbits.TRISB4 = 0x0;		// RB4		n/c
	TRISBbits.TRISB5 = 0x0;		// RB5		n/c
	TRISBbits.TRISB6 = 0x0;		// RB6		PGC
	TRISBbits.TRISB7 = 0x0;		// RB7		PGD


	/* PORT C */

	LATCbits.LATC0   = 0x0;		// RC0		n/c
	LATCbits.LATC1   = 0x0;		// RC1		RS
	LATCbits.LATC2   = 0x0;		// RC2		R/W
	LATCbits.LATC3   = 0x0;		// RC3		E
	LATCbits.LATC4   = 0x0;		// RC4		D4
	LATCbits.LATC5   = 0x0;		// RC5		D5
	LATCbits.LATC6   = 0x0;		// RC6		D6
	LATCbits.LATC7   = 0x0;		// RC7		D7

	TRISCbits.TRISC0 = 0x0;		// RC0		n/c
	TRISCbits.TRISC1 = 0x0;		// RC1		RS
	TRISCbits.TRISC2 = 0x0;		// RC2		R/W
	TRISCbits.TRISC3 = 0x0;		// RC3		E
	TRISCbits.TRISC4 = 0x0;		// RC4		D4
	TRISCbits.TRISC5 = 0x0;		// RC5		D5
	TRISCbits.TRISC6 = 0x0;		// RC6		D6
	TRISCbits.TRISC7 = 0x0;		// RC7		D7


	/* OSCILLATOR */
	OSCCON |= 0b01110000;		// CLK = 8MHz -> CPU speed = 2MHz


	/* ADC */
	ADCON2 = 0b10100101;		// ADC clock = Fosc/16 (500kHz), Aquisition time = 8 Tad (16s)
	ADCON1 = 0b00001101;		// ADC Voltage Reference = VDD/VSS, set AN0 and AN1 as ADC inputs
	ADCON0 = 0b00000001;		// enable ADC module


	/* TIMERS */
	T0CON = 0b00000111;			// TMR0 = 16bit timer, prescaler 1:256 (CLK = 2.000.000 / 256 = 7812.5Hz)
	T3CON = 0b10110100;			// TMR3 = 16bit timer, prescaler 1:8 (CLK = 2.000.000 / 8 = 256kHz)
	TMR3H = 0x0;				// reset TMR3
	TMR3L = 0x0;


	/* PULL-UP RESISTORS */
	INTCON2bits.RBPU = 0x0;		// enable pull-up resistors on port B


	/* INTERRUPT CONTROL */
	INTCONbits.TMR0IE = 0x1;	// enable TMR0 interrupts
	INTCONbits.PEIE = 0x1;		// enable peripheral interrupts (i.e. TMR3 interrupts)
	INTCONbits.GIE = 0x1;		// enable interrupts globally
}


