#include	<p18cxxx.h>
#include	<delays.h>
#include	"Regeltrafo.h"



void LCD_Init (void) {

	Delay1KTCYx(100);                   	// wait for 50ms to allow power-up

	LCD_senddata(LCD_INIT, 0b00110011);		// send 8-bit Init (two times)
	LCD_senddata(LCD_INIT, 0b00110010);		// send 8-bit Init and 4-bit Init

	LCD_senddata(LCD_INIT, 0b00101000);		// send 4-bit Init and Function Set (2 lines, 5x8 pixels)

	LCD_senddata(LCD_INIT, 0b00001000);		// display off
	LCD_senddata(LCD_INIT, 0b00000110);		// cursor increments, no display shift
	LCD_senddata(LCD_INIT, 0b00000001);		// clear display
	LCD_senddata(LCD_INIT, 0b00001100);		// display on

	// load special characters to CGRAM
	LCD_senddata(LCD_CMD,  0b01000000);		// set CGRAM address 0x0 to load special characters

	// '~'
	LCD_senddata(LCD_DATA, 0b00000000);		// send character data
	LCD_senddata(LCD_DATA, 0b00001000);		// send character data
	LCD_senddata(LCD_DATA, 0b00010101);		// send character data
	LCD_senddata(LCD_DATA, 0b00010101);		// send character data
	LCD_senddata(LCD_DATA, 0b00000010);		// send character data
	LCD_senddata(LCD_DATA, 0b00000000);		// send character data
	LCD_senddata(LCD_DATA, 0b00000000);		// send character data
	LCD_senddata(LCD_DATA, 0b00000000);		// send character data

	// 'V'
	LCD_senddata(LCD_DATA, 0b00000101);		// send character data
	LCD_senddata(LCD_DATA, 0b00000101);		// send character data
	LCD_senddata(LCD_DATA, 0b00000101);		// send character data
	LCD_senddata(LCD_DATA, 0b00000101);		// send character data
	LCD_senddata(LCD_DATA, 0b00000101);		// send character data
	LCD_senddata(LCD_DATA, 0b00000101);		// send character data
	LCD_senddata(LCD_DATA, 0b00000010);		// send character data
	LCD_senddata(LCD_DATA, 0b00000000);		// send character data

	// 'A'
	LCD_senddata(LCD_DATA, 0b00001000);		// send character data
	LCD_senddata(LCD_DATA, 0b00010100);		// send character data
	LCD_senddata(LCD_DATA, 0b00010100);		// send character data
	LCD_senddata(LCD_DATA, 0b00010100);		// send character data
	LCD_senddata(LCD_DATA, 0b00011100);		// send character data
	LCD_senddata(LCD_DATA, 0b00010100);		// send character data
	LCD_senddata(LCD_DATA, 0b00010100);		// send character data
	LCD_senddata(LCD_DATA, 0b00000000);		// send character data

	// 'v'
	LCD_senddata(LCD_DATA, 0b00000000);		// send character data
	LCD_senddata(LCD_DATA, 0b00000000);		// send character data
	LCD_senddata(LCD_DATA, 0b00000101);		// send character data
	LCD_senddata(LCD_DATA, 0b00000101);		// send character data
	LCD_senddata(LCD_DATA, 0b00000101);		// send character data
	LCD_senddata(LCD_DATA, 0b00000101);		// send character data
	LCD_senddata(LCD_DATA, 0b00000010);		// send character data
	LCD_senddata(LCD_DATA, 0b00000000);		// send character data

	// 'r'
	LCD_senddata(LCD_DATA, 0b00000000);		// send character data
	LCD_senddata(LCD_DATA, 0b00000000);		// send character data
	LCD_senddata(LCD_DATA, 0b00010100);		// send character data
	LCD_senddata(LCD_DATA, 0b00011000);		// send character data
	LCD_senddata(LCD_DATA, 0b00010000);		// send character data
	LCD_senddata(LCD_DATA, 0b00010000);		// send character data
	LCD_senddata(LCD_DATA, 0b00010000);		// send character data
	LCD_senddata(LCD_DATA, 0b00000000);		// send character data

	LCD_SetCursor (0,0);
}



void LCD_SetCursor (unsigned char x, unsigned char y) {

	switch (y) {
		case 0: LCD_senddata (LCD_CMD, 0x80+0x00+x); break;    // 1. Zeile
		case 1: LCD_senddata (LCD_CMD, 0x80+0x40+x); break;    // 2. Zeile
		case 2: LCD_senddata (LCD_CMD, 0x80+0x10+x); break;    // 3. Zeile
		case 3: LCD_senddata (LCD_CMD, 0x80+0x50+x); break;    // 4. Zeile
	}
}



void LCD_WriteString (char *buffer) {

	while (*buffer) {                 // Write data to LCD up to null
		LCD_senddata (LCD_DATA, *buffer); // Write character to LCD
		buffer++;               // Increment buffer
	}
}



void LCD_senddata (unsigned char type, unsigned char data) {

	_LCD_DATA_LAT = data & 0xF0;		// send upper nibble
	_LCD_RS = type;						// set RS pin if sending data
    _LCD_E=1;							// enable strobe
	Delay10TCYx(5);						// wait for 20s
    _LCD_E=0;
	if (type == LCD_INIT) {				// During init wait for 30ms
		Delay1KTCYx(20);					// to process command
	}
 
	_LCD_DATA_LAT = (data<<4) & 0xF0;	// send lower nibble
	_LCD_RS = type;						// set RS pin if sending data
    _LCD_E=1;							// enable strobe
	Delay10TCYx(4);						// wait for 20s
    _LCD_E=0;
	if (type == LCD_INIT) {				// During init wait for 30ms
		Delay1KTCYx(20);					// to process command
	}
}

